package at.jku.students;

import at.jku.ssw.ListNode;
import at.jku.ssw.Iterator;

/** An iterator for traversing a linked list. */
public class LinkedListIterator extends Iterator {

  private ListNode current;

  /** Creates an iterator for the linked list starting at head. */
  LinkedListIterator(ListNode head) {
    this.current = head;
  }

  /** Returns true if the iteration has more values. */
  public boolean hasNext() {
    return current != null;
  }

  /** Returns the next value in the iteration. */
  public Object next() {
    Object value = current.value;
    current = current.next;
    return value;
  }

}